//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  LimeGreen
#property indicator_color4  Orange
#property indicator_color5  DarkGray
#property indicator_color6  DarkGray
#property indicator_color7  DarkGray
#property indicator_color8  DarkGray

//
//
//
//
//

extern string StPeriods       = "10;15;20;";
extern string StMultipliers   = "1.7;1.7;1.7;";
extern string StTimeFrames    = "0;0;0;";
extern int    Price           = PRICE_CLOSE;
extern bool   TargetTimeFramePrice = false;
extern int    WickWidth       = 0;
extern int    BodyWidth       = 2;

//
//
//
//
//

double Buffer0[];
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double Buffer7[];

bool   returnBars;
string indicatorFileName;

int    size;
double periods[];
double multipliers[];
double timeframes[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,Buffer0); SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(1,Buffer1); SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(2,Buffer2); SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,BodyWidth);
   SetIndexBuffer(3,Buffer3); SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,BodyWidth);
   SetIndexBuffer(4,Buffer4); SetIndexStyle(4,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(5,Buffer5); SetIndexStyle(5,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(6,Buffer6); SetIndexStyle(6,DRAW_HISTOGRAM,EMPTY,BodyWidth);
   SetIndexBuffer(7,Buffer7); SetIndexStyle(7,DRAW_HISTOGRAM,EMPTY,BodyWidth);

      //
      //
      //
      //
      //
      
         if (StringSubstr(StPeriods,StringLen(StPeriods)-1,1) != ";")
                          StPeriods = StringConcatenate(StPeriods,";");
            int s = 0;
            int i = StringFind(StPeriods,";",s);
            double current;
               while (i > 0)
               {
                  current = StrToDouble(StringSubstr(StPeriods,s,i-s));
                  if (current > 0) {
                        ArrayResize(periods,ArraySize(periods)+1);
                                    periods[ArraySize(periods)-1] = current; }
                                    s = i + 1;
                                        i = StringFind(StPeriods,";",s);
               }
               size = ArraySize(periods);

         //
         //
         //
         //
         //
      
         if (StringSubstr(StMultipliers,StringLen(StMultipliers)-1,1) != ";")
                          StMultipliers = StringConcatenate(StMultipliers,";");
            s = 0;
            i = StringFind(StMultipliers,";",s);
               while (i > 0)
               {
                  current = StrToDouble(StringSubstr(StMultipliers,s,i-s));
                  if (current > 0) {
                        ArrayResize(multipliers,ArraySize(multipliers)+1);
                                    multipliers[ArraySize(multipliers)-1] = current; }
                                    s = i + 1;
                                        i = StringFind(StMultipliers,";",s);
               }
               
         //
         //
         //
         //
         //
                        
         if (StringSubstr(StTimeFrames,StringLen(StTimeFrames)-1,1) != ";")
                          StTimeFrames = StringConcatenate(StTimeFrames,";");
            s = 0;
            i = StringFind(StTimeFrames,";",s);
               while (i > 0)
               {
                  current = stringToTimeFrame(StringSubstr(StTimeFrames,s,i-s));
                  if (current > 0) {
                        ArrayResize(timeframes,ArraySize(timeframes)+1);
                                    timeframes[ArraySize(timeframes)-1] = current; }
                                    s = i + 1;
                                        i = StringFind(StTimeFrames,";",s);
               }


      //
      //
      //
      //
      //

         indicatorFileName = WindowExpertName();
         returnBars        = StPeriods=="returnBars";  if (returnBars) return(0);

   IndicatorShortName("supertrend rayphua");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Buffer0[0] = MathMin(limit+1,Bars-1); return(0); }
         for (int k=0; k<size; k++)
            if (timeframes[k]!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeframes[k],indicatorFileName,"returnBars",0,0)*timeframes[k]/Period()));
         

   //
   //
   //
   //
   //
   //

      for(int i=limit; i >= 0; i--)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         int    sum   = 0;
         for (k=0; k<size; k++)
         {
            int y = iBarShift(NULL,timeframes[k],Time[i]);
            if (TargetTimeFramePrice) price = iMA(NULL,timeframes[k],1,0,MODE_SMA,Price,y);
               double st = iCustom(NULL,timeframes[k],"SuperTrendXAlertsMtf","","",periods[k],multipliers[k],0,y);
               if (price>st) sum++;
               if (price<st) sum--;
         }
         Buffer0[i] = EMPTY_VALUE;
         Buffer1[i] = EMPTY_VALUE;
         Buffer2[i] = EMPTY_VALUE;
         Buffer3[i] = EMPTY_VALUE;
         Buffer4[i] = EMPTY_VALUE;
         Buffer5[i] = EMPTY_VALUE;
         Buffer6[i] = EMPTY_VALUE;
         Buffer7[i] = EMPTY_VALUE;
            if (sum== size) { Buffer0[i] = High[i]; Buffer1[i] = Low[i]; Buffer2[i] = MathMax(Open[i],Close[i]); Buffer3[i] = MathMin(Open[i],Close[i]); continue; }
            if (sum==-size) { Buffer1[i] = High[i]; Buffer0[i] = Low[i]; Buffer3[i] = MathMax(Open[i],Close[i]); Buffer2[i] = MathMin(Open[i],Close[i]); continue; }
                              Buffer4[i] = High[i]; Buffer5[i] = Low[i]; Buffer6[i] = Open[i]; Buffer7[i] = Close[i]; 
      }         
      return(0);
}
   

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}